﻿Imports System.Windows.Forms

Public Class Dialog1

    #Region "Sub OK_Button_Click : OKボタン."
        Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
            Me.DialogResult = System.Windows.Forms.DialogResult.OK
            Try
                ' リモートポート番号.
                IntPub_PortNo = Me.NUD_PortNo.Value
                ' 送信バッファサイズ.
                IntPub_SendBufferSize = Me.NUD_SendBuff.Value
                ' 送信時のタイムアウト値(ms単位).
                IntPub_SendTimeout = Me.NUD_SendTime.Value
                ' 受信バッファサイズ.
                IntPub_ReceiveBufferSize = Me.NUD_ReceiveBuff.Value
                ' 受信時のタイムアウト値(ms単位).
                IntPub_ReceiveTimeout = Me.NUD_ReceiveTime.Value
                ' 読み込み待ち時間.
                IntPub_PassiveModeCheckWaitTime = Me.NUD_ReadWaitTime.Value
                ' 送信命令直後に待つ待ち時間(ms単位).
                IntPub_SendAfterWaitTime = Me.NUD_SendWaitTime.Value
                ' アップロード時に「NOOP」命令を定期的に送信するかを設定.
                BlnPub_UploadSendNOOP = Me.Chk_UploadSendNOOP.Checked
                ' アップロード時に「NOOP」を送信するチェック回数を設定.
                IntPub_UploadSendNOOPCheckCount = Me.NUD_UploadSendNOOP.Value
                ' デフォルトのサーバー形式.
                IntPub_DefaultServer = Me.Cmb_DefaultServerForm.SelectedIndex
                ' 接続モード.
                IntPub_ConnectMode = Me.Cmb_ConnectMode.SelectedIndex
                ' テキストのエンコード種類.
                Select Case Me.Cmb_TextEncoding.SelectedIndex
                    Case 0
                        IntPub_TextEncoding = NSDFTP.NSDFtp_Connect_Info.TEXT_ENCODING.shift_jis
                    Case 1
                        IntPub_TextEncoding = NSDFTP.NSDFtp_Connect_Info.TEXT_ENCODING.iso_2022_jp
                    Case 2
                        IntPub_TextEncoding = NSDFTP.NSDFtp_Connect_Info.TEXT_ENCODING.euc_jp
                    Case 3
                        IntPub_TextEncoding = NSDFTP.NSDFtp_Connect_Info.TEXT_ENCODING.us_ascii
                End Select
            Catch ex As Exception
            Finally
            End Try
            Me.Close()
        End Sub
    #End Region

    #Region "Sub Cancel_Button_Click : キャンセルボタン."
        Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
            Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
            Me.Close()
        End Sub
    #End Region

    #Region "Sub Dialog1_Load : Loadイベント."
        Private Sub Dialog1_Load( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                ' リモートポート番号.
                Me.NUD_PortNo.Value = IntPub_PortNo
                ' 送信バッファサイズ.
                Me.NUD_SendBuff.Value = IntPub_SendBufferSize
                ' 送信時のタイムアウト値(ms単位).
                Me.NUD_SendTime.Value = IntPub_SendTimeout
                ' 受信バッファサイズ.
                Me.NUD_ReceiveBuff.Value = IntPub_ReceiveBufferSize
                ' 受信時のタイムアウト値(ms単位).
                Me.NUD_ReceiveTime.Value = IntPub_ReceiveTimeout
                ' 読み込み待ち時間.
                Me.NUD_ReadWaitTime.Value = IntPub_PassiveModeCheckWaitTime
                ' 送信命令直後に待つ待ち時間(ms単位).
                Me.NUD_SendWaitTime.Value = IntPub_SendAfterWaitTime
                ' アップロード時に「NOOP」命令を定期的に送信するかを設定.
                Me.Chk_UploadSendNOOP.Checked = BlnPub_UploadSendNOOP
                ' アップロード時に「NOOP」を送信するチェック回数を設定.
                Me.NUD_UploadSendNOOP.Value = IntPub_UploadSendNOOPCheckCount
                ' デフォルトのサーバー形式.
                Select Case IntPub_DefaultServer
                    Case NSDFTP.NSDFtp_Connect_Info.SERVER_FORM.UNIX_SERVER
                        Me.Cmb_DefaultServerForm.SelectedIndex = 0
                    Case NSDFTP.NSDFtp_Connect_Info.SERVER_FORM.WINDOWS_SERVER
                        Me.Cmb_DefaultServerForm.SelectedIndex = 1
                    Case NSDFTP.NSDFtp_Connect_Info.SERVER_FORM.MACOS_Peters_Server
                        Me.Cmb_DefaultServerForm.SelectedIndex = 2
                End Select
                ' 接続モード.
                With Me.Cmb_ConnectMode
                    .Items.Clear()

                    .Items.Add("アクティブモード")
                    .Items.Add("パッシブモード")

                    .SelectedIndex = IntPub_ConnectMode
                End With
                ' テキストのエンコード種類.
                Select Case IntPub_TextEncoding
                    Case NSDFTP.NSDFtp_Connect_Info.TEXT_ENCODING.shift_jis
                        Me.Cmb_TextEncoding.SelectedIndex = 0
                    Case NSDFTP.NSDFtp_Connect_Info.TEXT_ENCODING.iso_2022_jp
                        Me.Cmb_TextEncoding.SelectedIndex = 1
                    Case NSDFTP.NSDFtp_Connect_Info.TEXT_ENCODING.euc_jp
                        Me.Cmb_TextEncoding.SelectedIndex = 2
                    Case NSDFTP.NSDFtp_Connect_Info.TEXT_ENCODING.us_ascii
                        Me.Cmb_TextEncoding.SelectedIndex = 3
                End Select

                Chk_UploadSendNOOP_CheckedChanged_Sub()
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Chk_UploadSendNOOP_CheckedChanged : アップロード時に「NOOP」命令を送信する。"
        Private Sub Chk_UploadSendNOOP_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Chk_UploadSendNOOP.CheckedChanged
            Try
                Chk_UploadSendNOOP_CheckedChanged_Sub()
            Catch ex As Exception
            Finally
            End Try
        End Sub

        Private Sub Chk_UploadSendNOOP_CheckedChanged_Sub()
            Try
                Me.NUD_UploadSendNOOP.Enabled = Me.Chk_UploadSendNOOP.Checked
                Me.Lbl_SendNOOPCheckCount.Enabled = Me.Chk_UploadSendNOOP.Checked
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region
End Class
