﻿Public Class Form1
    #Region "Enum RUN_KIND : 動作種類(定数)."
        Enum RUN_KIND As Integer
            UnKnown = 0         ' 不明.
            Upload = 1          ' アップロード.
            Download = 2        ' ダウンロード.
            GetFileFolder = 3   ' ファイル、フォルダの取得.
        End Enum
    #End Region

    Dim IntCls_RunKind As RUN_KIND = RUN_KIND.UnKnown   ' 処理状態の確認用.
    Dim BlnCls_Cancel As Boolean = False                ' 中止の確認用.

    #Region "Sub Form1_FormClosed : フォームを閉じます."
        Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
            Try
                If Not (ClsPub_FTP Is Nothing) Then
                    ClsPub_FTP.Cls_Dispose()
                    ClsPub_FTP = Nothing
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Form1_FormClosing : フォームを閉じるかを指定します."
        Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
            Try
                Dim Bln_End As Boolean = False
                Dim Str_Msg As String = "プログラムを終了します。" & vbCrLf & "よろしいですか？"
                DIm Int_RunKind As RUN_KIND = RUN_KIND.UnKnown

                If Not (ClsPub_FTP Is Nothing) Then
                    If ClsPub_FTP.IsGetFileFolder() Then
                        Str_Msg = "ファイル、フォルダリストを取得中です." & vbCrLf & "中止しますか？"
                    ElseIf ClsPub_FTP.IsDownloadFile() Then
                        Str_Msg = "ファイルをダウンロード中です." & vbCrLf & "中止しますか？"
                    ElseIf ClsPub_FTP.IsUploadFile() Then
                        Str_Msg = "ファイルをアップロード中です." & vbCrLf & "中止しますか？"
                    Else
                        Bln_End = True
                    End If
                Else
                    Bln_End = True
                End If
                If MsgBox(Str_Msg, MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                    If Not Bln_End Then
                        e.Cancel = True
                        BlnCls_Cancel = True
                    End If
                Else
                    e.Cancel = True
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Form1_Load : Loadイベント."
        Private Sub Form1_Load( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                Me.Lbl_Msg.Text = ""
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Login_Click : リモートサーバーに接続します."
        Private Sub Btn_Login_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Login.Click
            Try
                Do
                    ' FTPアドレスを取得.
                    Dim Str_Url As String = Me.Text_FtpAddress.Text.Trim
                    If String.IsNullOrEmpty(Str_Url) Then
                        MsgBox("Ftpサイトを入力してください。")
                        Exit Do
                    End If

                    If (ClsPub_FTP Is Nothing) Then
                        ClsPub_FTP = New NSDFTP(Str_Url)
                    Else
                        Dim Str_Scheme As String = Nothing      ' スキーム名.
                        Dim Str_ServerName As String = Nothing  ' サーバー名.
                        Dim Str_UrlPath As String = Nothing     ' URLパス名.

                        ' FTPアドレスをセット.
                        If ClsPub_FTP.CrackUrl(Str_Url, Str_Scheme, Str_ServerName, Str_UrlPath) Then
                            ClsPub_FTP.FtpServer = Str_ServerName   ' サーバー名.
                            ClsPub_FTP.PathName = Str_UrlPath       ' パス名.
                        End If
                    End If
                
                    ' ログインIDをセットします.
                    ClsPub_FTP.UserName = Me.Text_LoginID.Text.Trim
                    ' パスワードをセットします.
                    ClsPub_FTP.Password = Me.Text_Password.Text.Trim

                    ' --------------------------
                    ' オプション内容をセット.
                    ' --------------------------
                        ' リモートポート番号.
                        ClsPub_FTP.PortNo = IntPub_PortNo
                        ' 送信バッファサイズ.
                        ClsPub_FTP.SendBufferSize = IntPub_SendBufferSize
                        ' 送信時のタイムアウト値(ms単位).
                        ClsPub_FTP.SendTimeout = IntPub_SendTimeout
                        ' 受信バッファサイズ.
                        ClsPub_FTP.ReceiveBufferSize = IntPub_ReceiveBufferSize
                        ' 受信時のタイムアウト値(ms単位).
                        ClsPub_FTP.ReceiveTimeout = IntPub_ReceiveTimeout
                        ' 読み込み待ち時間.
                        ClsPub_FTP.PassiveModeCheckWaitTime = IntPub_PassiveModeCheckWaitTime
                        ' 送信命令直後に待つ待ち時間(ms単位).
                        ClsPub_FTP.SendAfterWaitTime = IntPub_SendAfterWaitTime
                        ' アップロード時に「NOOP」命令を定期的に送信するかを設定.
                        ClsPub_FTP.UploadSendNOOP = BlnPub_UploadSendNOOP
                        ' アップロード時に「NOOP」を送信するチェック回数を設定.
                        ClsPub_FTP.UploadSendNOOPCheckCount = IntPub_UploadSendNOOPCheckCount
                        ' デフォルトのサーバー形式.
                        ClsPub_FTP.DefaultServerForm = IntPub_DefaultServer
                        ' 接続モード.
                        ClsPub_FTP.ConnectMode = IntPub_ConnectMode
                        ' テキストのエンコード種類.
                        ClsPub_FTP.TextEncoding = IntPub_TextEncoding

                    ' サーバーにログインします.
                    If ClsPub_FTP.Login() Then
                        Me.Lbl_ServerSystem.Text = "サーバーシステム：" & ClsPub_FTP.ServerSystem()
                        MsgBox("ログインしました。" & vbCrLf & "フォルダ、ファイルリストを取得します.")
                        SetControlEnabled(True)
                        ' フォルダ、ファイルリストを表示します.
                        GetFolderFileList()
                        Me.Btn_Login.Enabled = False
                        Me.Btn_Option.Enabled = False
                        Me.Panel3.Enabled = False
                    Else
                        MsgBox("ログインができません。" & vbCrLf & "FTPアドレス、ログインID、パスワードを確認してください。")
                    End If
                Loop While (0)
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_CloseConnection_Click : リモートサーバーの接続をクローズします."
        Private Sub Btn_CloseConnection_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_CloseConnection.Click
            Try
                If Not (ClsPub_FTP Is Nothing) Then
                    ClsPub_FTP.CloseConnection()
                    SetControlEnabled(False)
                End If
                Me.Btn_Login.Enabled = True
                Me.Btn_Option.Enabled = True
                Me.Panel3.Enabled = True
                Me.Lbl_ServerSystem.Text = "サーバーシステム："
                Me.ListView1.Items.Clear()
                Me.Lbl_CFolder.Text = ""
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub GetFolderFileList : サーバーからフォルダ、ファイル情報を取得しセットします."
        Private Sub GetFolderFileList()
            Try
                Me.ListView1.Items.Clear
                Me.Panel1.Enabled = False
                Me.Panel2.Enabled = True

                IntCls_RunKind = RUN_KIND.GetFileFolder
                BlnCls_Cancel = False

                Dim Cls_FileFolderList() As NSDFTP.FTP_FILE_FOLDER_INFO = Nothing
                ' Stop確認のイベントをセットします.
                AddHandler ClsPub_FTP.StopCheck_GetFileOrFolderList, AddressOf StopCheck_GetFileOrFolderList
                Try
                    ' フォルダ、ファイルリストを取得します.
                    Cls_FileFolderList = ClsPub_FTP.GetFileAndFolderInfo(False, True)
                Catch ex As Exception
                Finally
                    ' Stop確認のイベントを解放します.
                    RemoveHandler ClsPub_FTP.StopCheck_GetFileOrFolderList, AddressOf StopCheck_GetFileOrFolderList
                End Try

                If Not (Cls_FileFolderList Is Nothing) Then
                    For Int_Loop As Integer = 0 To Cls_FileFolderList.Length - 1
                        ' 名前.
                        Dim LItem As ListViewItem = Me.ListView1.Items.Add(Cls_FileFolderList(Int_Loop).Name)
                        LItem.Tag = Cls_FileFolderList(Int_Loop)
                        ' 種類.
                        Dim Str_Kind As String = "ファイル"
                        Select Case Cls_FileFolderList(Int_Loop).FileStyle
                            Case NSDFTP.FTP_FILE_OR_FOLDER.File_Only
                            Case NSDFTP.FTP_FILE_OR_FOLDER.Folder_Only
                                Str_Kind = "フォルダ"
                            Case NSDFTP.FTP_FILE_OR_FOLDER.symboliclink
                                Str_Kind = "シンボリックリンク"
                        End Select
                        LItem.SubItems.Add(Str_Kind)
                        ' サイズ.
                        Dim Str_Size As String = CStr(Cls_FileFolderList(Int_Loop).Size)
                        LItem.SubItems.Add(Str_Size)
                        ' タイムスタンプ.
                        Dim Str_TimeStamp As String = FormatDateTime(Cls_FileFolderList(Int_Loop).TimeStamp,DateFormat.GeneralDate)
                        LItem.SubItems.Add(Str_TimeStamp)
                        ' リンク先.
                        If Cls_FileFolderList(Int_Loop).FileStyle = NSDFTP.FTP_FILE_OR_FOLDER.symboliclink Then
                            ' リンク先.
                            LItem.SubItems.Add(Cls_FileFolderList(Int_Loop).Linked)
                            ' リンク先の種類.
                            Select Case Cls_FileFolderList(Int_Loop).LinkedFileStyle
                                Case NSDFTP.FTP_FILE_OR_FOLDER.File_Only
                                    Str_Kind = "ファイル"
                                Case NSDFTP.FTP_FILE_OR_FOLDER.Folder_Only
                                    Str_Kind = "フォルダ"
                                Case Else
                                    Str_Kind = "不明"
                            End Select
                            LItem.SubItems.Add(Str_Kind)
                        Else
                            ' リンク先.
                            LItem.SubItems.Add("")
                            ' リンク先の種類.
                            LItem.SubItems.Add("")
                        End If
                    Next Int_Loop
                End If
                ' カレントフォルダを表示します.
                DispCurrentFolder()
            Catch ex As Exception
            Finally
                Me.Lbl_Msg.Text = ""
                Me.Panel1.Enabled = True
                Me.Panel2.Enabled = False
            End Try
        End Sub
        
        Private Sub StopCheck_GetFileOrFolderList(ByRef ClsRef_FInfo() AS NSDFTP.FTP_FILE_FOLDER_INFO, ByRef BlnRef_Cancel As Boolean)
            Try
                Dim Int_No As Integer = 0
                If Not (ClsRef_FInfo Is Nothing) Then
                    Int_No = ClsRef_FInfo.Length
                End If
                Me.Lbl_Msg.Text = "ファイル、フォルダの取得(" &　CStr(Int_No) &  ")"
                Application.DoEvents()
                BlnRef_Cancel = BlnCls_Cancel
            Catch ex As Exception
            Finally
            End Try
        End Sub

    #End Region

    #Region "Sub SetControlEnabled : コントロールのEnbaledを設定します."
        Private Sub SetControlEnabled(ByVal BlnVal_Enabled As Boolean)
            Try
                ' 切断ボタン.
                Me.Btn_CloseConnection.Enabled = BlnVal_Enabled
                Me.Panel1.Enabled = BlnVal_Enabled
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub DispCurrentFolder : カレントフォルダを表示します."
        Private Sub DispCurrentFolder()
            Try
                Me.Lbl_CFolder.Text = ClsPub_FTP.GetCurrentFolder()
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Function GetSelectedItemIndex : ListViewの選択しているItemのインデックスを返します."
        Private Function GetSelectedItemIndex() As Integer
            Dim Int_Ret As Integer = -1
            Try
                If Not (Me.ListView1.SelectedItems Is Nothing) Then
                    Int_Ret = Me.ListView1.SelectedItems(0).Index
                End If
            Catch ex As Exception
            Finally
            End Try
            Return Int_Ret
        End Function
    #End Region

    #Region "Sub ListView1_MouseDoubleClick : ファイル、フォルダをダブルクリック."
        Private Sub ListView1_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ListView1.MouseDoubleClick
            Try
                Dim Bln_Folder As Boolean = False
                Dim Int_SelectIndex As Integer = GetSelectedItemIndex()
                If Int_SelectIndex <> -1 Then
                    With Me.ListView1.Items(Int_SelectIndex)
                        Dim Cls_FFInfo As NSDFTP.FTP_FILE_FOLDER_INFO = .Tag
                        Select Case Cls_FFInfo.FileStyle
                            Case NSDFTP.FTP_FILE_OR_FOLDER.File_Only
                                ' ファイル.
                                Btn_Download_Click_Sub()

                            Case NSDFTP.FTP_FILE_OR_FOLDER.Folder_Only, _
                                 NSDFTP.FTP_FILE_OR_FOLDER.symboliclink
                                ' フォルダ、シンボリックリンク.

                                ' フォルダを移動します.
                                If Cls_FFInfo.FileStyle = NSDFTP.FTP_FILE_OR_FOLDER.Folder_Only Then
                                    ' フォルダ.
                                    ClsPub_FTP.ChangeFolder(Cls_FFInfo.Name)
                                Else
                                    ' シンボリックリンク.
                                    ClsPub_FTP.ChangeFolder(Cls_FFInfo.Linked)
                                End If
                                ' フォルダ、ファイルリストを表示します.
                                GetFolderFileList()
                        End Select
                    End With
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_UpCurrentFolder_Click : カレントフォルダを一つ上位階層に移動します."
        Private Sub Btn_UpCurrentFolder_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_UpCurrentFolder.Click
            Try
                ClsPub_FTP.ChangeUpCurrentFolder()
                ' フォルダ、ファイルリストを表示します.
                GetFolderFileList()
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_ReName_Click : 名前を変更します."
        Private Sub Btn_ReName_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_ReName.Click
            Try
                Dim Int_SelectIndex As Integer = GetSelectedItemIndex()
                If Int_SelectIndex <> -1 Then
                    Dim Cls_FFInfo As NSDFTP.FTP_FILE_FOLDER_INFO = Me.ListView1.Items(Int_SelectIndex).Tag
                    Dim Str_Title As String = Nothing
                    If Cls_FFInfo.FileStyle = NSDFTP.FTP_FILE_OR_FOLDER.File_Only Then
                        Str_Title = "ファイル名"
                    Else
                        Str_Title = "フォルダ名"
                    End If
                    Dim Str_InptText As String = InputBox("変更する" & Str_Title & "を入力してください。", Str_Title & "の変更", Cls_FFInfo.Name)
                    Do
                        If String.IsNullOrEmpty(Str_InptText) Orelse _
                           Str_InptText.Trim = "" Then
                            Exit Do
                        End If
                        If Str_InptText = Cls_FFInfo.Name Then
                            ' 名前の変更なし.
                            Exit Do
                        End If
                        If ClsPub_FTP.RenameFile(Cls_FFInfo.Name, Str_InptText) Then
                            ' フォルダ、ファイルリストを表示します.
                            GetFolderFileList()
                        Else
                            MsgBox("名前の変更に失敗しました。")
                        End If
                    Loop While (0)
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_CreateFolder_Click : フォルダを作成します."
        Private Sub Btn_CreateFolder_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_CreateFolder.Click
            Try
                Dim Str_InptText As String = InputBox("作成するフォルダ名を入力してください。", "フォルダの作成", "新しいフォルダ名")
                Do
                    If String.IsNullOrEmpty(Str_InptText) Orelse _
                       Str_InptText.Trim = "" Then
                        MsgBox("フォルダ名が入力されていません。")
                        Exit Do
                    End If
                    ' フォルダを作成します.
                    If ClsPub_FTP.CreateFolder(Str_InptText) Then
                        MsgBox("フォルダを作成しました。")
                        ' フォルダ、ファイルリストを表示します.
                        GetFolderFileList()
                    Else
                        MsgBox("フォルダの作成に失敗しました。")
                    End If
                Loop While (0)
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Download_Click : ファイルのダウンロード."
        Private Sub Btn_Download_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Download.Click
            Try
                Btn_Download_Click_Sub()
            Catch ex As Exception
            Finally
            End Try
        End Sub

        Private Sub Btn_Download_Click_Sub()
            Try
                Dim Int_SelectIndex As Integer = GetSelectedItemIndex()
                If Int_SelectIndex <> -1 Then
                    With Me.ListView1.Items(Int_SelectIndex)
                        Dim Cls_FFInfo As NSDFTP.FTP_FILE_FOLDER_INFO = .Tag
                        Select Case Cls_FFInfo.FileStyle
                            Case NSDFTP.FTP_FILE_OR_FOLDER.File_Only
                                ' ファイル.
                                If MsgBox("ファイル「" & Cls_FFInfo.Name & "」をダウンロードします。" & vbCrLf & "よろしいですか？", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                                    Using FBD As New System.Windows.Forms.FolderBrowserDialog
                                        With FBD
                                            .Description = "ダウンロードファイルを保存するフォルダを選択します。"
                                            .ShowNewFolderButton = True
                                            If .ShowDialog = Windows.Forms.DialogResult.OK Then
                                                ' ファイルのダウンロード.
                                                Me.Panel1.Enabled = False
                                                Me.Panel2.Enabled = True
                                                IntCls_RunKind = RUN_KIND.Download
                                                BlnCls_Cancel = False

                                                With Me.ProgressBar1
                                                    .Value = 0
                                                    .Maximum = 1
                                                End With

                                                ' Stop確認のイベントをセットします.
                                                AddHandler ClsPub_FTP.StopCheck_DownloadFile, AddressOf StopCheck_DownloadFile

                                                Try
                                                    If ClsPub_FTP.DownloadFile(Cls_FFInfo.FullPath, .SelectedPath, True) Then
                                                        If MsgBox("ファイルをダウンロードしました。" & vbCrLf & "ダウンロード先のフォルダを表示しますか？", vbYesNo) = MsgBoxResult.Yes Then
                                                            System.Diagnostics.Process.Start(.SelectedPath)
                                                        End If
                                                    Else
                                                        MsgBox("ファイルのダウンロードに失敗しました。")
                                                    End If
                                                Catch ex As Exception
                                                Finally
                                                    ' Stop確認のイベントを解放します.
                                                    RemoveHandler ClsPub_FTP.StopCheck_DownloadFile, AddressOf StopCheck_DownloadFile

                                                    With Me.ProgressBar1
                                                        .Value = 0
                                                    End With
                                                    Me.Panel1.Enabled = True
                                                    Me.Panel2.Enabled = False
                                                End Try
                                            End If
                                        End With
                                    End Using
                                End If

                            Case NSDFTP.FTP_FILE_OR_FOLDER.Folder_Only, _
                                 NSDFTP.FTP_FILE_OR_FOLDER.symboliclink
                                ' フォルダ、シンボリックリンク.

                                MsgBox("ファイルを選択してください。")
                        End Select
                    End With
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub

        Private Sub StopCheck_DownloadFile(ByVal BlnVal_SizeSet As Boolean, ByVal LngVal_RemoteFileSize As Long, ByVal LngVal_DownloadSize As Long, ByRef BlnRef_Cancel As Boolean)
            Try
                If BlnVal_SizeSet Then
                    With Me.ProgressBar1
                        .Maximum = LngVal_RemoteFileSize
                        .Value = LngVal_DownloadSize
                    End With
                    Me.Lbl_Msg.Text = "ダウンロード(" &　CStr(LngVal_DownloadSize) & "/" & CStr(LngVal_RemoteFileSize) &  ")"
                End If
                Application.DoEvents()
                BlnRef_Cancel = BlnCls_Cancel
            Catch ex As Exception
            Finally
            End Try
        End Sub
        
    #End Region

    #Region "Sub Btn_Upload_Click : ファイルのアップロード"
        Private Sub Btn_Upload_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Upload.Click
            Try
                Using FD As New System.Windows.Forms.OpenFileDialog
                    With FD
                        .Title = "サーバーに転送するファイルを選択します。"
                        .Multiselect = False
                        If .ShowDialog = Windows.Forms.DialogResult.OK Then
                            Me.Panel1.Enabled = False
                            Me.Panel2.Enabled = True
                            IntCls_RunKind = RUN_KIND.Upload
                            BlnCls_Cancel = False

                            With Me.ProgressBar1
                                .Value = 0
                                .Maximum = 1
                            End With

                            ' Stop確認のイベントをセットします.
                            AddHandler ClsPub_FTP.StopCheck_UploadFile, AddressOf StopCheck_UploadFile
                            
                            Try
                                If ClsPub_FTP.UploadFile(.FileName, True) Then
                                    MsgBox("ファイルのアップロードに成功しました。")
                                Else
                                    MsgBox("ファイルのアップロードに失敗しました。")
                                End If
                            Catch ex As Exception
                            Finally
                                ' フォルダ、ファイルリストを表示します.
                                GetFolderFileList()
                                ' Stop確認のイベントを解放します.
                                RemoveHandler ClsPub_FTP.StopCheck_UploadFile, AddressOf StopCheck_UploadFile

                                With Me.ProgressBar1
                                    .Value = 0
                                End With
                                Me.Panel1.Enabled = True
                                Me.Panel2.Enabled = False
                            End Try
                        End If
                    End With
                End Using
            Catch ex As Exception
            Finally
            End Try
        End Sub

        Private Sub StopCheck_UploadFile(ByVal BlnVal_SizeSet As Boolean, ByVal LngVal_LocalFileSize As Long, ByVal LngVal_UploadSize As Long, ByRef BlnRef_Cancel As Boolean)
            Try
                If BlnVal_SizeSet Then
                    With Me.ProgressBar1
                        .Maximum = LngVal_LocalFileSize
                        .Value = LngVal_UploadSize
                    End With
                    Me.Lbl_Msg.Text = "アップロード(" &　CStr(LngVal_UploadSize) & "/" & CStr(LngVal_LocalFileSize) &  ")"
                End If
                Application.DoEvents()
                BlnRef_Cancel = BlnCls_Cancel
            Catch ex As Exception
            Finally
            End Try
        End Sub

    #End Region

    #Region "Sub Btn_Delete_Click : ファイル、フォルダを削除します."
        Private Sub Btn_Delete_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Delete.Click
            Try
                Dim Int_SelectIndex As Integer = GetSelectedItemIndex()
                If Int_SelectIndex <> -1 Then
                    With Me.ListView1.Items(Int_SelectIndex)
                        Dim Cls_FFInfo As NSDFTP.FTP_FILE_FOLDER_INFO = .Tag
                        Dim Bln_DeleteOk As Boolean = False
                        Select Case Cls_FFInfo.FileStyle
                            Case NSDFTP.FTP_FILE_OR_FOLDER.File_Only
                                ' ファイル.
                                If MsgBox("ファイル「" & Cls_FFInfo.Name & "」を削除します。" & vbCrLf & "削除したファイルは、復元できません。" & vbcrlf & "削除してよろしいですか？", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                                    If ClsPub_FTP.DeleteFile(Cls_FFInfo.FullPath) Then
                                        MsgBox("削除しました。")
                                        ' フォルダ、ファイルリストを表示します.
                                        GetFolderFileList()
                                    Else
                                        MsgBox("削除に失敗しました。")
                                    End If
                                End If

                            Case NSDFTP.FTP_FILE_OR_FOLDER.Folder_Only
                                ' フォルダ.
                                If MsgBox("フォルダ「" & Cls_FFInfo.Name & "」を削除します。" & vbCrLf & "削除したフォルダは、復元できません。" & vbcrlf & "削除してよろしいですか？", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                                    If ClsPub_FTP.RemoveFolder(Cls_FFInfo.FullPath) Then
                                        MsgBox("削除しました。")
                                        ' フォルダ、ファイルリストを表示します.
                                        GetFolderFileList()
                                    Else
                                        MsgBox("削除に失敗しました。")
                                    End If
                                End If

                            Case NSDFTP.FTP_FILE_OR_FOLDER.symboliclink
                                ' シンボリックリンク.
                                MsgBox("選択しているファイル、フォルダはシンボリックリンクです。" & vbCrLf & "シンボリックリンクは、削除できません。") 
                        End Select
                    End With
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Stop_Click : 中止処理."
        Private Sub Btn_Stop_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Stop.Click
            Try
                Dim Str_Msg As String = Nothing
                Select Case IntCls_RunKind
                    Case RUN_KIND.Upload
                        Str_Msg = "ファイルのアップロードを中止します。"
                    Case RUN_KIND.Download
                        Str_Msg = "ファイルのダウンロードを中止します。"
                    Case RUN_KIND.GetFileFolder
                        Str_Msg = "ファイル、フォルダ情報の検索を中止します。"
                End Select
                Str_Msg &= vbCrLf & "よろしいですか？"
                If MsgBox(Str_Msg, MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                    BlnCls_Cancel = True
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Option_Click : オプション."
        Private Sub Btn_Option_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Option.Click
            Try
                Using OPD As New Dialog1
                    OPD.ShowDialog()
                End Using
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Chk_Password_CheckedChanged : パスワードを表示."
        Private Sub Chk_Password_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Chk_Password.CheckedChanged
            Try
                If CType(sender, CheckBox).Checked Then
                    Me.Text_Password.PasswordChar = ""
                Else
                    Me.Text_Password.PasswordChar = "*"
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

End Class
